local Gamers = {}
function Gamers.setup_chair(self)
	local unit = self._unit

	self._s_body = unit:get_object(Idstring("s_body"))

	self._chair_unit =
		World:spawn_unit(Idstring("units/world/architecture/hospital/props/wheelchair01/wheelchair01"), Vector3(0, 0, 0), unit:rotation())

	if not alive(self._chair_unit) then
		return
	end

	for index = 0, self._chair_unit:num_bodies() - 1, 1 do
		local body = self._chair_unit:body(index)

		if body then
			body:set_collisions_enabled(false)
			body:set_collides_with_mover(false)
			body:set_enabled(false)
		end
	end
end

function Gamers.update_chair(self)
	if not self._s_body then
		Gamers.setup_chair(self)
		return
	end

	local chair = self._chair_unit
	if not alive(chair) then
		return
	end

	self._unit:play_redirect(Idstring("so_apartment_sit_idle"))

	local u_pos = self._unit:position()
	local s_body_pos, s_body_rot = self._s_body:position(), self._s_body:rotation()

	chair:set_position(Vector3(u_pos.x - (u_pos.x - s_body_pos.x), u_pos.y - (u_pos.y - s_body_pos.y), u_pos.z))

	chair:set_rotation(Rotation(s_body_rot:yaw() + 90, 0, 0))
end

function Gamers.destroy_chair(self)
	local chair = self._chair_unit
	if not alive(chair) then
		return
	end

	chair:set_slot(0)
end

local hooks = {
	["lib/network/extensions/player/huskplayermovement"] = "HuskPlayerMovement",
	["lib/units/player_team/teamaimovement"] = "TeamAIMovement",
}

local class_name = hooks[RequiredScript]
if class_name then
	if class_name == "TeamAIMovement" and not D:conf("enable_team_ai_gaming_chairs") then
		return
	end

	local c = module:hook_class(class_name)

	module:post_hook(c, "update", Gamers.update_chair)
	module:post_hook(c, "pre_destroy", Gamers.destroy_chair)
end
